<template>
  <section id="dashboard">
    <h2 class="text-center">Top Heroes</h2>
    <div class="row">
      <div class="col-md-3" v-for="hero in orderedUsers" :key="hero.id">
        <n-link class="module" :to='`/detail/${ hero.id }`'>
          <h4>{{ hero.name }}</h4>
        </n-link>
      </div>
    </div>
    <div class="row mt-4 mb-4">
      <div class="col-md-12 mb-2">
        <h4>Hero search</h4>
      </div>
      <div class="input-group col-md-5">
        <div class="input-group-prepend">
          <span class="input-group-text" id="inputGroup-sizing-default">Hero search</span>
        </div>
        <input type="text" class="form-control" aria-label="Default" v-model="heroSearchName"
               aria-describedby="inputGroup-default">
        <div class="col-md-12 p-0" v-if="heroSearchList.length > 0">
          <ul class="search-bar" name="list-animation">
            <li class="search-bar-list" v-for="heroSearch in heroSearchList" :key="heroSearch.id">
              <n-link class="search-bar-name" :to='`/detail/${ heroSearch.id }`'>
                <div class="name">{{ heroSearch.name }}</div>
              </n-link>
            </li>
          </ul>
        </div>
      </div>
    </div>
  </section>
</template>

<script>
  import { mapActions } from 'vuex'
  export default {
    name: "Dashboard",
    data () {
      return {
        heroSearchName: '',
        heroList: this.$store.getters['heroes/getHeroes'],
        heroSearchList: []
      }
    },
    computed: {
      orderedUsers: function () {
        const vm = this
        const dataFilter = Object.assign([], vm.heroList)
        return dataFilter.slice(1,5)
      }
    },
    watch: {
      heroSearchName (value) {
        const vm = this
        vm.heroSearchList.splice(0)
        if(value) {
          vm.heroList.filter((hero) => {
            let firstLetter = hero.name.toLowerCase()
            if (firstLetter.indexOf(value.toLowerCase()) > -1) {
              vm.heroSearchList.push(hero)
            }
          })
          vm.heroSearchList.length > 0 ? vm.addMessages(`Found heroes matching "${value}"`) : vm.addMessages(`Not found heroes matching "${value}"`)
        }
      }
    },
    methods: {
      ...mapActions({
        addMessages: 'setMessages',
      }),
    }
  }
</script>

<style lang="scss" scoped>
  #dashboard {
    .module {
      margin-top: 10px;
      display: flex;
      height: 120px;
      border-radius: 2px;
      justify-content: center;
      align-items: center;
      color: #eee;
      text-decoration: none;
      background-color: #3f525c;
      &:hover {
        background-color: #EEE;
        cursor: pointer;
        color: #607d8b;
      }
    }
    .search-bar {
      position: absolute;
      background: white;
      width: 75%;
      z-index: 1;
      padding: 0;
      right: 0;
      .search-bar-list {
        list-style: none;
        margin-top: 3px;
        align-items: center;
        background-color: #e9edf0;
        border-radius: 4px;
        border: 1px solid #e3e3e3;
        transition: all 0.5s;
        &:hover {
          background-color: #607D8B !important;
          cursor: pointer;
        }
        .search-bar-name {
          text-decoration: none;
          position: relative;
          display: flex;
          width: 100%;
          .name {
            width: 100%;
            color: #4c4c4c;
            display: flex;
            align-items: center;
            padding: 5px 10px;
            &:hover {
              color: white !important;
            }
          }
        }
      }
    }
  }
</style>
